/*
This file is part of »zeitbild«.

Copyright 2025 'kcf' <fenris@folksprak.org>

»zeitbild« is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

»zeitbild« is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with »zeitbild«. If not, see <http://www.gnu.org/licenses/>.
 */


namespace _zeitbild.api
{
	
	/**
	 */
	export function register_calendar_add(
		rest_subject : lib_plankton.rest_http.type_rest
	) : void
	{
		register<
			{
				name : string;
				access : {
					public : boolean;
					default_level : string;
					attributed_group : Array<
						{
							group_id : int;
							level : string;
						}
					>;
					attributed_user : Array<
						{
							user_id : int;
							level : string;
						}
					>;
				};
				resource : (
					{
						kind : "local";
						data : {
						};
					}
					|
					{
						kind : "ics_feed";
						data : {
							url : string;
							from_fucked_up_wordpress : boolean;
						};
					}
				);
				hue : float;
			},
			int
		>(
			rest_subject,
			lib_plankton.http.enum_method.post,
			"/calendar",
			{
				"description": "erstellt einen Kalender",
				"input_schema": () => ({
					"nullable": true,
					// TODO
				}),
				"output_schema": () => ({
					"nullable": true,
					"type": "integer",
				}),
				"restriction": restriction_logged_in,
				"execution": async (stuff) => {
					const session : {key : string; value : lib_plankton.session.type_session;} = await session_from_stuff(stuff);
					const user_id : _zeitbild.type_user_id = await _zeitbild.service.user.identify(session.value.name);
					
					if (stuff.input === null) {
						return Promise.reject(new Error("impossible"));
					}
					else {
						// TODO move logic to calendar service
						let resource_object : _zeitbild.type_resource_object;
						switch (stuff.input.resource.kind)
						{
							case "local": {
								resource_object = {
									"kind": "local",
									"data": {
										"event_ids": [],
									}
								};
								break;
							}
							case "ics_feed": {
								resource_object = {
									"kind": "ics_feed",
									"data": {
										"url": stuff.input.resource.data.url,
										"from_fucked_up_wordpress": stuff.input.resource.data.from_fucked_up_wordpress,
									}
								};
								break;
							}
						}
						const resource_id : _zeitbild.type_resource_id = await _zeitbild.service.resource.add(
							resource_object
						);
						const calendar_object : _zeitbild.type_calendar_object = {
							"name": stuff.input.name,
							"access": {
								"public": stuff.input.access.public,
								"default_level": _zeitbild.access_level_from_string(stuff.input.access.default_level),
								"attributed_group": lib_plankton.map.hashmap.implementation_map(
									lib_plankton.map.hashmap.make(
										x => x.toFixed(0),
										{
											"pairs": (
												stuff.input.access.attributed_group
												.map(
													(entry) => ({
														"key": entry.group_id,
														"value": _zeitbild.access_level_from_string(entry.level),
													})
												)
											),
										}
									)
								),
								"attributed_user": lib_plankton.map.hashmap.implementation_map(
									lib_plankton.map.hashmap.make(
										x => x.toFixed(0),
										{
											"pairs": (
												stuff.input.access.attributed_user
												.map(
													(entry) => ({
														"key": entry.user_id,
														"value": _zeitbild.access_level_from_string(entry.level),
													})
												)
												.concat(
													[
														{
															"key": user_id,
															"value": _zeitbild.enum_access_level.admin,
														}
													]
												)
											),
										}
									)
								),
							},
							"resource_id": resource_id,
							"hue": stuff.input.hue,
						};
						return (
							_zeitbild.service.calendar.add(calendar_object)
							.then(
								(calendar_id : _zeitbild.type_calendar_id) => Promise.resolve({
									"status_code": 200,
									"data": calendar_id,
								})
							)
						);
					}
				}
			}
		);
	}
	
}
